SystemOrganization addCategory: #ExtentionsForKendrick!

Object subclass: #KendrickEquations
	instanceVariableNames: 'eqAsSymExpr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

!KendrickEquations methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2016 13:05'!
convertToCompatibleBackendRepresentation

	^ ((eqAsSymExpr asString
			copyReplaceAll: '#' with: '' asTokens: false)
			trimBoth: [ :c | (c = $() | (c = $)) ]) 
			findTokens: '''.'''! !

!KendrickEquations methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/4/2016 17:57'!
with: symExpression

	eqAsSymExpr := symExpression ! !

Object subclass: #KendrickInternalDSLEntities
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

KendrickInternalDSLEntities class
	instanceVariableNames: 'storedInstances'!

KendrickInternalDSLEntities class
	instanceVariableNames: 'storedInstances'!

KendrickInternalDSLEntities subclass: #Kendrick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

!Kendrick class methodsFor: 'public-api' stamp: 'NickPapoulias 4/11/2016 15:18'!
composition

	^ KendrickComposition new! !

!Kendrick class methodsFor: 'public-api' stamp: 'NickPapoulias 4/11/2016 11:47'!
concern

	^ KendrickConcern new! !

!Kendrick class methodsFor: 'public-api' stamp: 'NickPapoulias 4/4/2016 17:44'!
model

	^ KendrickModel new! !

Kendrick subclass: #KendrickComposition
	instanceVariableNames: 'model concerns compartments parameters keModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

!KendrickComposition methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/11/2016 17:34'!
addCompositeAtrributeOrParameter: variable value: value

	|variablePlusAttributes|
	
	variablePlusAttributes := variable asString findTokens: '_'.
	"assume single attribute for the time being"
	
	(model attributeValuesIncludes: variablePlusAttributes first)
		ifTrue: [ 
			self addCompositeAttribute: variablePlusAttributes value: value. 
		] ifFalse: [  
		(parameters keys includes: variablePlusAttributes first)
			ifTrue: [  
				self addCompositeParameter: variablePlusAttributes value: value.
			] ifFalse: [ 
					KendrickDSLSyntaxError 
								signal: 'Undefined Variable Being Set: ' , variable asString ]. 
		].
	! !

!KendrickComposition methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/11/2016 15:54'!
addCompositeAttribute: variablePlusAttributes value: value

	compartments at: variablePlusAttributes put: value.
	(self allCompositeReferencesFor: variablePlusAttributes)
		doWithIndex: [:ref :index|  
			model atCompartment: ref put: (value at: index).		
		]! !

!KendrickComposition methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/11/2016 16:06'!
addCompositeParameter: variablePlusAttributes value: value.

	parameters at: variablePlusAttributes put: value.
	keModel 
        atParameter: variablePlusAttributes first
        assignValue: 
        [ :aModel| |c index| 
            c := aModel currentCompartment at: variablePlusAttributes last.
				index := (model attributes at: variablePlusAttributes last) indexOf: c.            
				value at: index
        ].

! !

!KendrickComposition methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/11/2016 17:47'!
allCompositeReferencesFor: variablePlusAttributes

	|attribute compartment entity|
	compartment := variablePlusAttributes first.
	attribute := variablePlusAttributes last.
	entity := ((concerns copy add: model; yourself) select: [ :e | e attributes keys 
		includes: (variablePlusAttributes last)]) first.
	^ (entity attributes at: variablePlusAttributes last) 
			collect: [:comp | 
				{self referencesFor: compartment . (variablePlusAttributes last) -> comp}
			]
	! !

!KendrickComposition methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/11/2016 17:26'!
concern: aString
	|concern|
	concern := KendrickConcern withId: aString.
	concerns add: concern.
	keModel integrate: concern keConcern.! !

!KendrickComposition methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/11/2016 17:27'!
doesNotUnderstand: aMessage

	|variable value|
	
	variable := aMessage selector.
	variable := (variable asString trimRight: [: c | c =  $:]) asSymbol.
	value := aMessage arguments first.
 
	(model attributeValuesIncludes: variable)
		ifTrue: [ 
			compartments add: {variable -> value}.
			model atCompartment: variable value: value. 
		] ifFalse: [  
		(parameters keys includes: variable)
			ifTrue: [  
				parameters at: variable put: value.
				model addParameter: variable value: value. "can be array here treat differently"
			] ifFalse: [ 
					(aMessage selector asString includes: $_)
						ifTrue: [ self addCompositeAtrributeOrParameter: variable value: value ]
						ifFalse: [  
							KendrickDSLSyntaxError 
								signal: 'Undefined Variable Being Set: ' , variable asString
						] 
					]. 
		].! !

!KendrickComposition methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/11/2016 17:21'!
initialize

	concerns := OrderedCollection new. 
	compartments := Dictionary new. 
	parameters := Dictionary new.
	! !

!KendrickComposition methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/11/2016 15:32'!
model: aString

	model := KendrickModel withId: aString.
	keModel := model keModel ! !

!KendrickComposition methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/11/2016 15:57'!
referencesFor: anAttribute

	|assoc|

	assoc := (model attributes 
		associations select: [ :as | as value includes: anAttribute ]) first.
	^ { assoc key -> anAttribute  }

	! !

Kendrick subclass: #KendrickConcern
	instanceVariableNames: 'population attributes parameters equations explicitelySetCompartments otherCompartmentValue transitions keConcern'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

!KendrickConcern methodsFor: 'public-api' stamp: 'NickPapoulias 4/11/2016 17:24'!
attribute: anArray

	attributes at: anArray first put: anArray allButFirst.
	keConcern addAttribute: anArray first value: anArray allButFirst  
	! !

!KendrickConcern methodsFor: 'protected' stamp: 'NickPapoulias 4/11/2016 11:07'!
attributeValuesIncludes: variable

	^ (attributes values select: [ :values | values includes: variable ]) isEmpty not! !

!KendrickConcern methodsFor: 'protected' stamp: 'NickPapoulias 4/11/2016 17:48'!
attributes

	^ attributes
	! !

!KendrickConcern methodsFor: 'public-api' stamp: 'NickPapoulias 4/11/2016 11:57'!
doesNotUnderstand: aMessage

	|variable value|
	
	variable := aMessage selector.
	variable := (variable asString trimRight: [: c | c =  $:]) asSymbol.
	value := aMessage arguments first.
 
	(self attributeValuesIncludes: variable)
		ifTrue: [ 
			explicitelySetCompartments add: {variable->value}.
		] ifFalse: [  
		(parameters keys includes: variable)
			ifTrue: [  
				parameters at: variable put: value.
			] ifFalse: [ 
					KendrickDSLSyntaxError 
								signal: 'Undefined Variable Being Set: ' , variable asString ]. 
		].
	
	! !

!KendrickConcern methodsFor: 'public-api' stamp: 'NickPapoulias 4/11/2016 11:57'!
equations: anArrayOfSymExpressions

	equations :=
		KendrickEquations new with: anArrayOfSymExpressions.
! !

!KendrickConcern methodsFor: 'protected' stamp: 'NickPapoulias 4/11/2016 17:24'!
initialize

	attributes := Dictionary new.
	parameters := Dictionary new.
	explicitelySetCompartments := OrderedCollection new.
	keConcern := KEConcern new.
! !

!KendrickConcern methodsFor: 'protected' stamp: 'NickPapoulias 4/11/2016 17:25'!
keConcern

	^ keConcern.
! !

!KendrickConcern methodsFor: 'public-api' stamp: 'NickPapoulias 4/11/2016 11:59'!
others: anInteger

	otherCompartmentValue := anInteger.! !

!KendrickConcern methodsFor: 'protected' stamp: 'NickPapoulias 4/11/2016 17:48'!
parameters

	^ parameters ! !

!KendrickConcern methodsFor: 'public-api' stamp: 'NickPapoulias 4/11/2016 11:07'!
parameters: anArray

	anArray do: [ :var | parameters at: var put: 0 ]! !

!KendrickConcern methodsFor: 'public-api' stamp: 'NickPapoulias 4/11/2016 11:58'!
population: anInteger

	population := anInteger.! !

!KendrickConcern methodsFor: 'public-api' stamp: 'NickPapoulias 4/11/2016 11:58'!
transitions: aSymExpression

	transitions :=
		KendrickEquations new with: aSymExpression.
! !

Kendrick subclass: #KendrickModel
	instanceVariableNames: 'population attributes parameters equations keModel explicitelySetCompartments otherCompartmentValue transitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

!KendrickModel methodsFor: 'protected' stamp: 'NickPapoulias 4/11/2016 15:12'!
addParameter: variable value: value

	value isNumber 
		ifTrue: [keModel addParameter: variable value: value]
		ifFalse: [ "array" 
			keModel 
				addParameter: variable 
				value: (self covertSymbolicExpressionToBlock: value).
		]! !

!KendrickModel methodsFor: 'protected' stamp: 'NickPapoulias 4/11/2016 15:15'!
atCompartment: variable value: value

	|assoc|

	assoc := (attributes associations select: [ :as | as value includes: variable ]) first.
	keModel atCompartment: { assoc key -> variable } put: value
	! !

!KendrickModel methodsFor: 'public-api' stamp: 'NickPapoulias 4/11/2016 10:17'!
attribute: anArray

	attributes at: anArray first put: anArray allButFirst.
	keModel addAttribute: anArray first value: anArray allButFirst.  ! !

!KendrickModel methodsFor: 'protected' stamp: 'NickPapoulias 4/11/2016 15:09'!
attributeOrParameter: aName

	^ (parameters includes: aName)
		ifTrue: [ keModel atParameter: aName ]
		ifFalse: [  
			|assoc|
			assoc := (attributes associations select: [ :as | as value includes: aName ]) first.
			keModel atCompartment: { assoc key -> aName }
		]
	! !

!KendrickModel methodsFor: 'protected' stamp: 'NickPapoulias 4/4/2016 17:28'!
attributeValuesIncludes: variable

	^ (attributes values select: [ :values | values includes: variable ]) isEmpty not! !

!KendrickModel methodsFor: 'protected' stamp: 'NickPapoulias 4/11/2016 17:30'!
attributes

	^ attributes! !

!KendrickModel methodsFor: 'protected' stamp: 'NickPapoulias 4/11/2016 15:12'!
covertSymbolicExpressionToBlock: anArray

			|body|
			body := (anArray collect: [ :token | 
				(#(- + * / sum sqrt size) includes: token)
					ifTrue: [ token asString ]
					ifFalse: [ '(self attributeOrParameter: ' , token asString , ')' ]			
			]) inject: '' into: [ :expr :token | 
				(#(sum sqrt size) includes: token)
					ifFalse: [expr , ' ' , token]
					ifTrue: [ '(' , expr , ')' , token ]
			].
			Compiler new		evaluate: '[' , body , ']'
					in: thisContext sender
					to: thisContext sender receiver
					notifying: nil
					ifFail: [^nil]
					logged: false.! !

!KendrickModel methodsFor: 'public-api' stamp: 'NickPapoulias 4/11/2016 14:32'!
doesNotUnderstand: aMessage

	|variable value|
	
	variable := aMessage selector.
	variable := (variable asString trimRight: [: c | c =  $:]) asSymbol.
	value := aMessage arguments first.
 
	(self attributeValuesIncludes: variable)
		ifTrue: [ 
			explicitelySetCompartments add: variable.
			self atCompartment: variable value: value. 
		] ifFalse: [  
		(parameters keys includes: variable)
			ifTrue: [  
				parameters at: variable put: value.
				self addParameter: variable value: value. "can be array here treat differently"
			] ifFalse: [ 
					KendrickDSLSyntaxError 
								signal: 'Undefined Variable Being Set: ' , variable asString ]. 
		].
	
	! !

!KendrickModel methodsFor: 'public-api' stamp: 'NickPapoulias 4/5/2016 13:06'!
equations: anArrayOfSymExpressions

	equations :=
		KendrickEquations new with: anArrayOfSymExpressions.
	keModel addEquations: equations convertToCompatibleBackendRepresentation.
	! !

!KendrickModel methodsFor: 'protected' stamp: 'NickPapoulias 4/4/2016 17:41'!
initialize

	keModel := KEModel new.
	attributes := Dictionary new.
	parameters := Dictionary new.
	explicitelySetCompartments := OrderedCollection new.! !

!KendrickModel methodsFor: 'protected' stamp: 'NickPapoulias 4/5/2016 16:27'!
keModel

	^ keModel! !

!KendrickModel methodsFor: 'public-api' stamp: 'NickPapoulias 4/5/2016 16:05'!
others: anInteger

	otherCompartmentValue := anInteger.

	keModel attributes
		associationsDo: [ :assoc | 
			assoc value do: [:var |
				(explicitelySetCompartments includes: var)
					ifFalse: [ self atCompartment: var value: anInteger ]
			] 
		]! !

!KendrickModel methodsFor: 'protected' stamp: 'NickPapoulias 4/11/2016 17:30'!
parameters

	^ parameters ! !

!KendrickModel methodsFor: 'public-api' stamp: 'NickPapoulias 4/11/2016 10:04'!
parameters: anArray

	anArray do: [ :var | parameters at: var put: 0 ]! !

!KendrickModel methodsFor: 'public-api' stamp: 'NickPapoulias 4/5/2016 15:51'!
population: anInteger

	population := anInteger.
	keModel population: (KEPopulation size: anInteger).! !

!KendrickModel methodsFor: 'protected' stamp: 'NickPapoulias 4/11/2016 17:15'!
transitionRefFor: aCompartment
	
	|assoc|

	aCompartment = 'All'
		ifTrue: [ ^ {attributes keys first -> #each} ].
	aCompartment = 'Empty'
		ifTrue: [ ^ #empty ].
	assoc := (attributes associations select: [ :pair | pair value includes: aCompartment ]) first.
	^ '{#' , assoc key asString , ': #' , aCompartment , '}'.! !

!KendrickModel methodsFor: 'public-api' stamp: 'NickPapoulias 4/11/2016 16:34'!
transitions: aSymExpression

	transitions :=
		KendrickTransitions new with: aSymExpression.
	transitions convertToCompatibleBackendRepresentation do: [:assoc |
		|from to propability|
		from := assoc key key.
		propability := assoc key value.
		to := assoc value.
		keModel
   			addTransitionFrom: (self transitionRefFor: from)
   			to: (self transitionRefFor: to)
   			probability: [ :m | m atParameter: propability ].	
	]! !

!KendrickInternalDSLEntities class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2016 16:23'!
clearAll

	self allSubclassesDo: [ :subclass | subclass clearAllInstances ]! !

!KendrickInternalDSLEntities class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2016 16:20'!
clearAllInstances

	storedInstances := nil! !

!KendrickInternalDSLEntities class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2016 16:22'!
new

	^ self storedInstances addFirst: self basicNew initialize! !

!KendrickInternalDSLEntities class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2016 16:20'!
storedInstances

	^ storedInstances ifNil: [ storedInstances := OrderedCollection new ]! !

!KendrickInternalDSLEntities class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2016 16:19'!
withId: anId

	^ (self storedInstances select: [ :instance | instance id = anId ]) first.! !

!KendrickInternalDSLEntities methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/11/2016 16:31'!
doesNotUnderstand: aMessage

	KendrickDSLSyntaxError signal: self class name , ' has no keyword ' , aMessage selector.! !

!KendrickInternalDSLEntities methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/4/2016 16:51'!
id

	^ id! !

!KendrickInternalDSLEntities methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/4/2016 16:52'!
id: aString

	id := aString! !

KendrickInternalDSLEntities subclass: #Simulation
	instanceVariableNames: 'algo model from to step simulator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

!Simulation class methodsFor: 'public-api' stamp: 'NickPapoulias 4/11/2016 16:20'!
gillepsie

	^ self new 
		with: #Gillespie! !

!Simulation class methodsFor: 'public-api' stamp: 'NickPapoulias 4/5/2016 15:24'!
rungeKutta

	^ self new 
		with: #RungeKutta! !

!Simulation methodsFor: 'protected' stamp: 'NickPapoulias 4/5/2016 15:38'!
allTimeSeries

	^ simulator allTimeSeries ! !

!Simulation methodsFor: 'protected' stamp: 'NickPapoulias 4/5/2016 16:27'!
execute

	simulator := KESimulator new: algo from: from to: to step: step.
	simulator executeOn: model keModel.! !

!Simulation methodsFor: 'public-api' stamp: 'NickPapoulias 4/5/2016 15:26'!
for: aModelID

	model := KendrickModel withId: aModelID.! !

!Simulation methodsFor: 'public-api' stamp: 'NickPapoulias 4/5/2016 15:27'!
from: aNumber

	from := aNumber! !

!Simulation methodsFor: 'public-api' stamp: 'NickPapoulias 4/5/2016 15:29'!
step: aNumber

	step := aNumber! !

!Simulation methodsFor: 'public-api' stamp: 'NickPapoulias 4/5/2016 15:27'!
to: aNumber

	to := aNumber! !

!Simulation methodsFor: 'public-api' stamp: 'NickPapoulias 4/5/2016 15:24'!
with: anAlgorithm

	algo := anAlgorithm ! !

KendrickInternalDSLEntities subclass: #Visualization
	instanceVariableNames: 'simulation xLabel diag builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

!Visualization class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2016 15:43'!
diagram

	^ Visualization new 
		with: KEDiagramBuilder! !

!Visualization methodsFor: 'public-api' stamp: 'NickPapoulias 4/11/2016 16:15'!
data: anArray

	builder data: (simulation 
		timeSeriesAt: 
			((simulation model transitionRefFor: anArray first) perform: anArray last))! !

!Visualization methodsFor: 'public-api' stamp: 'NickPapoulias 4/5/2016 16:06'!
for: simulationID

	simulation := Simulation withId: simulationID.! !

!Visualization methodsFor: 'protected' stamp: 'NickPapoulias 4/5/2016 16:21'!
open

	simulation execute.
	diag := builder new data: simulation allTimeSeries.
	diag xLabel: xLabel.
	diag open! !

!Visualization methodsFor: 'protected' stamp: 'NickPapoulias 4/5/2016 15:44'!
with: aBuilder

	builder := aBuilder! !

!Visualization methodsFor: 'public-api' stamp: 'NickPapoulias 4/5/2016 15:36'!
xLabel: aString

	xLabel := aString! !

Object subclass: #KendrickTransitions
	instanceVariableNames: 'eqAsSymExpr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

!KendrickTransitions methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/11/2016 11:31'!
convertToCompatibleBackendRepresentation

	|transitions currentTransition|

	transitions := OrderedCollection new.
	currentTransition := nil.

	eqAsSymExpr  do: [ :token | 
		token = #->
			ifTrue: [  
				"do nothing"
			] ifFalse: [ 
				token = #'.'
					ifTrue: [ transitions add: currentTransition. currentTransition := nil ]
					ifFalse: [ 
						currentTransition = nil 
							ifTrue: [ currentTransition := token ]
							ifFalse: [ currentTransition := currentTransition -> token ]  
					]
			]
	].

	^ transitions 

	! !

!KendrickTransitions methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/11/2016 11:30'!
with: symExpression

	eqAsSymExpr := symExpression ! !

Error subclass: #KendrickDSLSyntaxError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

TestCase subclass: #TestMeaslesScripts
	instanceVariableNames: 'beforeSimulator afterSimulator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

!TestMeaslesScripts methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/11/2016 10:20'!
after

Kendrick model	
	id: 'Measles';
	attribute: #(status S E I R);
	parameters: #(beta gamma mu sigma); 
	equations: #(
	  S:t=mu*N - beta*S*I - mu*S.
      E:t=beta*S*I - sigma*E - mu*E.
      I:t=sigma*E - gamma*I - mu*I.
      R:t=gamma*I - mu*R.
	);
	population: 100000;
	S: 99999;
	I: 1;
	others: 0;
	beta: 0.0000214;
	gamma: 0.143;
	mu: 0.0000351;
	sigma: 0.125.	
		
Simulation rungeKutta		
	id: 'MeaslesRKSim';
	for: 'Measles';
	from: 0.0; 
	to: 150; 
	step: 1.
	
Visualization diagram 
	id: 'MeaslesDiagramViz';
	for: 'MeaslesRKSim';
	xLabel: 'Time (days)'.! !

!TestMeaslesScripts methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2016 16:32'!
before

| model simulator diag |
model := KEModel new population: (KEPopulation size: 100000).
model addAttribute: #status value: #(S E I R).
model atCompartment: { #status->#S } put: 99999 atOthersPut: 0.
model atCompartment: { #status->#I } put: 1.
model addEquations: { 
            'S:t=mu*N - beta*S*I - mu*S'.
            'E:t=beta*S*I - sigma*E - mu*E'.
            'I:t=sigma*E - gamma*I - mu*I'.
            'R:t=gamma*I - mu*R'
            }.
model addParameters: {
        #beta->0.0000214. 
        #gamma->0.143. 
        #mu->0.0000351. 
        #sigma->0.125 }.
simulator := KESimulator new: #RungeKutta from: 0.0 to: 150 step: 1.
simulator executeOn: model.
diag := (KEDiagramBuilder new) data: simulator allTimeSeries.
diag xLabel: 'Time (days)'.
diag open.

^ simulator! !

!TestMeaslesScripts methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2016 16:38'!
setUp

	beforeSimulator := self before.
	self after. "we grab references by id to show-case how tools should handle the declarative dsl"
	afterSimulator := Simulation withId: 'MeaslesRKSim'.
	(Visualization withId: 'MeaslesDiagramViz') open.! !

!TestMeaslesScripts methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2016 16:34'!
tearDown

	KendrickInternalDSLEntities clearAll.! !

!TestMeaslesScripts methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2016 16:48'!
testEquivalence

	self assert: 
		(beforeSimulator allTimeSeries collect: [ :ts | ts peakOfEpidemic  ]) = 
		(afterSimulator allTimeSeries collect: [ :ts | ts peakOfEpidemic  ])! !

TestCase subclass: #TestMosquitoScripts
	instanceVariableNames: 'beforeSimulator afterSimulator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

!TestMosquitoScripts methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/11/2016 16:32'!
after

Kendrick model
	id: 'Mosquito';
	population: 13000;
	attribute: #(status S I R); 
	parameters: #(mu gamma beta lambda rho N);
	mu: 12.17;
	gamma: 52;
	beta: 1;
	lambda: #(beta*I);
	transitions: #(
		S -> lambda -> I.
		I -> gamma -> R.
		All -> mu -> Empty.
		Empty -> mu -> S.
	).

Kendrick concern
	id: 'SpeciesConcern';
	attribute: #(species mosquito reservoir1 reservoir2);
	mosquito: 10000;
	reservoir1: 1000;
	reservoir2: 2000.
		
Kendrick composition
	model: 'Mosquito';
	concern: 'SpeciesConcern';	
	S_species: #(9999 1000 2000);
	I_species: #(1 0 0);
	N: #(species size);
	others: 0;
	mu_species: #(12.17. 0.05. 0.05);
	rho_species: #(
		#(0 0.02 0.02) 
		#(0.02 0 0) 
		#(0.02 0 0)
	);
	lambda: #(beta*rho*I sum).

Simulation gillepsie
	id: 'MosquitoGillepsie';
	for: 'Mosquito';
	from: 0.0; 
	to: 0.5; 
	step: 0.0027.
	
Visualization diagram 
	id: 'MosquitoDiagramViz';
	for: 'MosquitoGillepsie';
	data: #(I sqrt)
	xLabel: 'Time (days)'.! !

!TestMosquitoScripts methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/6/2016 16:51'!
before

| model multiHostConcern simulator db |
model := KEModel new.
model population: (KEPopulation size: 13000).
model attributes: {(#status -> #(#S #I #R))}.
model addParameter: #mu value: 12.17.
model addParameter: #gamma value: 52.
model addParameter: #beta value: 1.
model addParameter: #lambda value: [ :aModel| 
        (aModel atParameter: #beta) * 
        (aModel atCompartment: {#status->#I}) ].
model
   addTransitionFrom: '{#status: #S}'
   to: '{#status: #I}'
   probability: [ :m | m atParameter: #lambda ].
model 
   addTransitionFrom: '{#status: #I}' 
   to: '{#status: #R}' 
        probability: [ :m | m atParameter: #gamma ].
    #(#S #I #R) do: [ :each| 
        model 
            addTransitionFrom: {#status->each} 
            to: #empty 
            probability: [ :m | m atParameter: #mu ].
        ].
model 
        addTransitionFrom: #empty 
        to: '{#status: #S}' 
        probability: [ :m | m atParameter: #mu ].

multiHostConcern := KEConcern new.
multiHostConcern 
   addAttribute: #species 
   value: #(#mosquito #reservoir1 #reservoir2).

model integrate: multiHostConcern.

model 
        atParameter: #mu
        assignValue: 
        [ :aModel| |c val| 
            c := aModel currentCompartment at: #species.
            c = #mosquito ifTrue: [ val := 12.17 ].
            c = #reservoir1 ifTrue: [ val := 0.05 ].
            c = #reservoir2 ifTrue: [ val := 0.05 ].
            val
        ].
model atParameter: #N assignValue: [ :aModel| |c| 
        c := aModel currentCompartment at: #species.
        aModel sizeOfPopulation: c
        ].
model addParameter: #rho value: [ :aModel| |c val|
        c := aModel currentCompartment at: #species.
        c = #mosquito ifTrue: [ val := #(0 0.02 0.02) ].
        c = #reservoir1 ifTrue: [ val := #(0.02 0 0) ].
        c = #reservoir2 ifTrue: [ val := #(0.02 0 0) ].
        val
        ].
model atParameter: #lambda assignValue: [ :aModel|
        ((aModel atParameter: #beta) * 
        (aModel atParameter: #rho) * 
        (aModel atCompartment: {#status->#I})) sum
        ].

    model atCompartment: { #status->#I. #species->#mosquito } put: 1 atOthersPut: 0.
    model atCompartment: { #status->#S. #species->#mosquito } put: 9999.
    model atCompartment: { #status->#S. #species->#reservoir1 } put: 1000.
    model atCompartment: { #status->#S. #species->#reservoir2 } put: 2000.

simulator := KESimulator new: #Gillespie from: 0.0 to: 0.5 step: 0.0027.
simulator executeOn: model.
db := (KEDiagramBuilder new) data: ((simulator timeSeriesAt: '{#status: #I}') sqrt).
db open.

^ simulator! !

!TestMosquitoScripts methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/11/2016 17:15'!
setUp

	KendrickInternalDSLEntities clearAll.

	self after.
	afterSimulator := Simulation withId: 'MosquitoGillepsie'.
	beforeSimulator := self before.
	(Visualization withId: 'MosquitoDiagramViz') open.! !

!TestMosquitoScripts methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/6/2016 16:50'!
tearDown

	KendrickInternalDSLEntities clearAll.! !

!TestMosquitoScripts methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/11/2016 16:25'!
testEquivalence

	self assert: 
		(beforeSimulator allTimeSeries collect: [ :ts | ts peakOfEpidemic  ]) = 
		(afterSimulator allTimeSeries collect: [ :ts | ts peakOfEpidemic  ])! !

TestCase subclass: #TestOneSpeciesSpatialScripts
	instanceVariableNames: 'beforeSimulator afterSimulator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExtentionsForKendrick'!

!TestOneSpeciesSpatialScripts methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/6/2016 17:02'!
after

Kendrick model
	id: 'OneSpeciesSpatial';
	population: 5000.

Kendrick concern
	id: 'Spatial';
	attribute: #(patch 1  2  3  4  5);
	rho: 0.03;
	transitions: #(
		1 -> rho -> 2.
		2 -> rho -> 3.
		3 -> rho -> 4.
		4 -> rho -> 5.
		5 -> rho -> 1.
	).
		
Kendrick concern
	id: 'Epidemiological';
	attribute: #(status S  E  I  R);
	lambda: #(beta*I*N);
	transitions: #(
		S -> lambda -> E.
		E -> sigma -> I.
		I -> gamma -> R.
		R -> v -> S.
		All -> mu -> Empty.
		Empty -> mu -> All.
	);
	v: 0.00274;
	mu: 0.0000365;
	sigma: 0.5;
	gamma: 0.25.
		
Kendrick composition
	model: 'OneSpeciesSpatial';
	concern: 'Spatial';
	concern: 'Epidemiological';
	beta: #(
			1 -> 0.75.
			_ -> 0.5.
	);
	N: #(patch size);
	lambda: #(patch beta*I*N);
	S: #(1 900 2 1000 3 1000 4 1000 5 1000);
	I: #(1 100);
	others: 0.
		
Simulation rungeKutta
	id: 'SpatialRungeKutta';
	for: 'OneSpeciesSpatial';
	from: 0; 
	to: 500; 
	step: 1.
	
Visualization diagram 
	id: 'SpatialDiagramViz';
	for: 'SpatialRungeKutta';
	data: #(allTimeSeries);
	legends: {'patch 1' . 'patch 2' . 'patch 3' . 'patch 4' . 'patch 5'};
	legendTitle: 'Infectious';
	xLabel: 'Time (days)'.! !

!TestOneSpeciesSpatialScripts methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/6/2016 16:59'!
before

| spatialConcern seirsConcern model simulator db |
spatialConcern := KEConcern new.
 spatialConcern addAttribute: #patch value: (1 to: 5) asArray.
 spatialConcern addParameter: #rho.
 (1 to: 5) do: [ :i| 
     (i < 5) 
     ifTrue: [  
         spatialConcern 
             addTransitionFrom: { #patch->i } 
             to: { #patch->(i+1) } 
             probability: [ :aModel| aModel atParameter: #rho ].
     ]
     ifFalse: [  
         spatialConcern 
             addTransitionFrom: { #patch->i } 
             to: { #patch->1 } 
             probability: [ :aModel| aModel atParameter: #rho ].
     ]
 ]. 

seirsConcern := KEConcern new.
 seirsConcern attributes: {#status->#(#S #E #I #R)}.
 seirsConcern addParameters: { #beta. #gamma. #mu. #sigma. #v }.
 seirsConcern addParameter: #lambda value: [ :aModel | 
         (aModel atParameter: #beta) * 
         (aModel atCompartment: {#status->#I}) / (aModel atParameter: #N) ].
 seirsConcern
     addTransitionFrom: '{#status: #S}'
     to: '{#status: #E}'
     probability: [ :aModel | 
         (aModel atParameter: #lambda) ].
 seirsConcern 
     addTransitionFrom: '{#status: #E}' 
     to: '{#status: #I}' 
     probability: [ :aModel | aModel atParameter: #sigma ].
 seirsConcern 
     addTransitionFrom: '{#status: #I}' 
     to: '{#status: #R}' 
     probability: [ :aModel | aModel atParameter: #gamma ].
 seirsConcern 
     addTransitionFrom: '{#status: #R}' 
     to: '{#status: #S}' 
     probability: [ :aModel | aModel atParameter: #v ].
 #(S E I R) do: [ :each| 
     seirsConcern 
         addTransitionFrom: {#status->each}
         to: #empty 
         probability: [ :aModel | aModel atParameter: #mu ].
     ].
 seirsConcern 
     addTransitionFrom: #empty 
     to: '{#status: #S}' 
     probability: [ :aModel | aModel atParameter: #mu ].

     model := KEModel new.
 model population: (KEPopulation size: 5000).
 model integrate: spatialConcern.
 model integrate: seirsConcern.

model atParameter: #beta assignValue: [ :aModel| |c val| 
     c := aModel currentCompartment at: #patch.
     c = 1 ifTrue: [ val := 0.75 ] ifFalse: [ val := 0.5 ].
     val 
 ].
 model atParameter: #v assignValue: 0.00274.
 model atParameter: #mu assignValue: 0.0000365.
 model atParameter: #sigma assignValue: 0.5.
 model atParameter: #gamma assignValue: 0.25.
 model atParameter: #N assignValue: [ :aModel| |c| 
     c := aModel currentCompartment at: #patch.
     aModel sizeOfPopulation: c
     ].
 model atParameter: #rho assignValue: 0.03. 
 model atParameter: #lambda assignValue: [ :aModel| |c|
     c := aModel currentCompartment at: #patch.
     (aModel atParameter: #beta) * (aModel atCompartment: {#status->#I. #patch->c}) / (aModel atParameter: #N)
 ].

model atCompartment: { #status->#S. #patch->1 } put: 900 atOthersPut: 0.
 model atCompartment: { #status->#I. #patch->1 } put: 100.
 model atCompartment: { #status->#S. #patch->2 } put: 1000.
 model atCompartment: { #status->#S. #patch->3 } put: 1000.
 model atCompartment: { #status->#S. #patch->4 } put: 1000.
 model atCompartment: { #status->#S. #patch->5 } put: 1000.

simulator := KESimulator new: #RungeKutta from: 0 to: 500 step: 1.
 simulator executeOn: model.
 db := KEDiagramBuilder new.
 db data: [|tmp| tmp := OrderedCollection new.
 tmp addAll: (simulator timeSeriesAt: '{#status: #I,#patch:1}').
 tmp addAll: (simulator timeSeriesAt: '{#status: #I,#patch:2}').
 tmp addAll: (simulator timeSeriesAt: '{#status: #I,#patch:3}').
 tmp addAll: (simulator timeSeriesAt: '{#status: #I,#patch:4}').
 tmp addAll: (simulator timeSeriesAt: '{#status: #I,#patch:5}').
 tmp] value.
 db legends: { 'patch 1'. 'patch 2'. 'patch 3'. 'patch 4'. 'patch 5'}.
 db legendTitle: 'Infectious'.
 db xLabel: 'Time (days)'.
 db open! !

!TestOneSpeciesSpatialScripts methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/6/2016 17:03'!
setUp

	"beforeSimulator := self before.
	self after.
	afterSimulator := Simulation withId: 'SpatialDiagramViz'.
	(Visualization withId: 'SpatialRungeKutta') open."! !

!TestOneSpeciesSpatialScripts methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/6/2016 16:58'!
tearDown

	KendrickInternalDSLEntities clearAll.! !

!TestOneSpeciesSpatialScripts methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/6/2016 16:58'!
testEquivalence

	"self assert: 
		(beforeSimulator allTimeSeries collect: [ :ts | ts peakOfEpidemic  ]) = 
		(afterSimulator allTimeSeries collect: [ :ts | ts peakOfEpidemic  ])"! !
